/*--------------------------------------------------------------------------+
$Id: codetemplates.xml 1 2011-01-01 00:00:01Z hoelzl $
|                                                                          |
| Copyright 2017 fortiss GmbH                     |
|                                                                          |
| Licensed under the Apache License, Version 2.0 (the "License");          |
| you may not use this file except in compliance with the License.         |
| You may obtain a copy of the License at                                  |
|                                                                          |
|    http://www.apache.org/licenses/LICENSE-2.0                            |
|                                                                          |
| Unless required by applicable law or agreed to in writing, software      |
| distributed under the License is distributed on an "AS IS" BASIS,        |
| WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied. |
| See the License for the specific language governing permissions and      |
| limitations under the License.                                           |
+--------------------------------------------------------------------------*/
package org.fortiss.af3.platform.raspberry.generator.executable.gamepad;

import static org.fortiss.af3.expression.utils.ExpressionModelElementFactory.funcCall;

import org.fortiss.af3.component.model.InputPort;
import org.fortiss.af3.expression.model.terms.IExpressionTerm;
import org.fortiss.af3.platform.language.executable.ReceiverExecutableBase;
import org.fortiss.af3.platform.raspberry.model.gamepad.ButtonR1;

/**
 * Executable for {@link ButtonR1}.
 * 
 * @author eder
 * @author $Author: hoelzl $
 * @version $Rev: 18709 $
 * @ConQAT.Rating RED Hash:
 */
public class ButtonR1Executable extends ReceiverExecutableBase<ButtonR1> {

	/** Constructor. */
	public ButtonR1Executable(ButtonR1 modelElement) {
		super(modelElement);
	}

	public IExpressionTerm getInitialization() {
		return funcCall("gp_init");
	}

	public IExpressionTerm getNoValGuardAccessor(InputPort logicalSignal) {
		return funcCall("gp_btnR1_is_noval");
	}

	public IExpressionTerm getTermination() {
		return funcCall("gp_term");
	}

	public IExpressionTerm getValueReadAccessor(InputPort logicalSignal) {
		return funcCall("gp_btnR1_read");
	}
}
